    					/*------------------------------------------------------+
						  |				     DataFile.cpp						|
						  |														|
						  |	 class ki permet de rcuprer facilement se kil y   |
						  |		dans un GTZ ( une surcouche koa en fait )	    |
						  |														|
						  | 	U2^PoPsy TeAm 2000								|
						  +-----------------------------------------------------*/

#include "U3D3.h"

//----------------------------------------------------------------------------------------------------------
////////////////////////////////////////////////////////////////////////////////////////////////////////////
//									+-----------------------+
//									|	 Class DataFile		|
//									+-----------------------+
////////////////////////////////////////////////////////////////////////////////////////////////////////////
//----------------------------------------------------------------------------------------------------------
DataManager::DataManager()
{
	pack = NULL	;
}
//----------------------------------------------------------------------------------------------------------
DataManager::~DataManager()
{
	if( pack ) delete pack	;
}
//----------------------------------------------------------------------------------------------------------
// renvoie TRUE si succes sinon FALSE ( pf on l'aurai pas devin )
void DataManager::LoadGTZ( CArchive &ar )
{
	pack = new GTZpack(NULL)	;
	pack->Serialize( ar )		;
}
//----------------------------------------------------------------------------------------------------------
BOOL DataManager::LoadGTZ( LPCSTR nom )
{
	CFile file	;

	if( file.Open( nom, CFile::modeRead ) )
	TRY
	{
		CArchive ar(&file, CArchive::load )	;

		/*pack = new GTZpack(NULL)	;
		pack->Serialize( ar )		;*/
		LoadGTZ( ar )	;

		ar.Close()		;
		file.Close()	;
	}
	CATCH_ALL(e)
	{
		return FALSE	;
	}
	END_CATCH_ALL
	else
	{
		return FALSE	;
	}

	return TRUE	;	
}
//----------------------------------------------------------------------------------------------------------
// voir fonctions danbs pack.h (de la  GTZLib )
CByteArray* DataManager::GetData( LPCSTR nom,BOOL destruc )
{
	if( ! pack )	return NULL	;

	CByteArray* ret = pack->GetData( nom, destruc )	;

#ifdef _DEBUG
	if( !ret )
		DebugErrorMess( "<U3D> GTZ file missing : %s\n", nom )	;
#endif

	return ret	;
}
//----------------------------------------------------------------------------------------------------------
// voir fonctions danbs pack.h (de la  GTZLib )
CByteArray* DataManager::GetDataFolder( LPCSTR nom,BOOL destruc )
{
	if( !pack )	return NULL	;

	CByteArray* ret = pack->GetDataFolder( nom, destruc )	;

#ifdef _DEBUG
	if( !ret )
		DebugErrorMess( "<U3D> GTZ file missing : %s\n", nom )	;
#endif

	return ret	;
}
//----------------------------------------------------------------------------------------------------------
